<?php
class Ittweb_Cvetta_Model_Search_Layer extends Mage_CatalogSearch_Model_Layer
{
	protected $facets;
    protected $host;

    function __construct()
    {
        $this->host = Mage::getStoreConfig('cvetta/settings/staging') ? 'http://ws10b.cvetta.io/searchDeb.php' : 'http://ws10b.cvetta.io/search.php';
    }

	
	/** 
	 * @return Mage_Catalog_Model_Resource_Eav_Resource_Product_Collection
	 */
	public function getProductCollection()
	{
		$vetrina_prefix = Mage::getStoreConfig('cvetta/settings/idvetrina') ? Mage::getStoreConfig('cvetta/settings/idvetrina') : Mage::getStoreConfig('cvetta/settings/username');

		$q = urlencode(Mage::app()->getRequest()->getParam('q'));
		$id_vetrina = $vetrina_prefix . '_'.substr(Mage::app()->getLocale()->getLocaleCode(), 0, 2);
		$mode = Mage::app()->getRequest()->getParam('mode', substr(Mage::getStoreConfig('catalog/frontend/list_mode'), 0, 4));
		$rows = Mage::app()->getRequest()->getParam('limit', Mage::getStoreConfig('catalog/frontend/'.$mode.'_per_page'));
		$start = (Mage::app()->getRequest()->getParam('p', 1) - 1) * $rows;
		$sort = Mage::app()->getRequest()->getParam('order', 'score');
		$dir = Mage::app()->getRequest()->getParam('dir', $sort == 'score' ? 'desc' : 'asc');
		$facets_label = Mage::app()->getRequest()->getParam('facets_label', array());
		$facets_value = Mage::app()->getRequest()->getParam('facets_value', array());
		$params = '';
        //$cookie = new stdClass;
		foreach($facets_label as $i => $facet_label) {
		    $facet_label_decoded = urldecode($facet_label);
            //$cookie->{$facet_label_decoded}[] = urldecode($facets_value[$i]);
			$params .= '|ff=' . $facet_label_decoded . ":" . urldecode($facets_value[$i]);
		}
		
        /*$_COOKIE["cvetta.search.facets"] = json_encode($cookie);
        //die('wwwww');
        //setrawcookie("cvetta.search.facets", $cookie);
        echo "<pre>";
        echo print_r($cookie);
        echo "</pre>";
        echo "<pre>";
        echo print_r($_COOKIE);
        echo "</pre>";*/
		$params = urlencode($params);

		$url = $this->host . '?qt=find&q='.$q.'&params='.$params.'&start='.$start.'&rows='.$rows.'&idvetrina='.$id_vetrina.'&sort='.$sort.'+'.$dir;
      

        $ch = curl_init();
        $curlOptArr = array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => TRUE,
            CURLOPT_CUSTOMREQUEST => "GET",
        );
        curl_setopt_array($ch, $curlOptArr);
        $output = curl_exec($ch);
        curl_close($ch);

        $output = substr($output, 11, -1);
		$output = json_decode($output, true);


		$numFound = $output["response"]["numFound"];
		$products = $output["response"]["docs"];
		$facet_ranges = array();
		foreach ($output["facet_counts"]["facet_ranges"] as $facet => $facet_values) {
			foreach($facet_values["counts"] as $value => $count) {
				//$this->facets["facet_ranges"][$facet][] = '['.$count.'+TO+'.($count+$counts["gap"]).']';
				$facet_ranges["facet_ranges"][$facet]['['.$value.'+TO+'.($value+$facet_values["gap"]).']'] = $count;
			}
		}
		$this->facets = array_merge(array("facet_fields" => $output["facet_counts"]["facet_fields"]), $facet_ranges);

		$ids = array();
        $orderString = '';
        if (count($products)) {
            $orderString = array('CASE e.entity_id');
            $i = 0;
            foreach ($products as $product) {
                $ids[] = $product["id"];
                $orderString[] = 'WHEN '.$product["id"].' THEN '.$i;
                $i++;
            }
            $orderString[] = 'END';
            $orderString = implode(' ', $orderString);
        }
	
		//$collection = Mage::getModel('catalog/product')->getCollection();
		$collection = Mage::getResourceModel('ittweb_cvetta/product_collection');
		$collection->getSelect()->where('e.entity_id IN (?)', $ids)->order(new Zend_Db_Expr($orderString));

		$collection->setTotalRecords($numFound);

		$collection->addAttributeToSelect(Mage::getSingleton('catalog/config')->getProductAttributes());
		$collection
			->setStore(Mage::app()->getStore())
            ->addMinimalPrice()
            ->addFinalPrice()
            ->addTaxPercents()
            ->addStoreFilter()
            ->addUrlRewrite()
			;

		//Mage::log($collection->getSelect()->__toString(), null, 'ittweb_cvetta.log');
		
		return $collection;
	}
	
	public function getFacets()
	{
		/*RINDONDANTE*/
		$q = urlencode(Mage::app()->getRequest()->getParam('q'));
		$id_vetrina = Mage::getStoreConfig('cvetta/settings/username').'_'.substr(Mage::app()->getLocale()->getLocaleCode(), 0, 2);
		$mode = Mage::app()->getRequest()->getParam('mode', substr(Mage::getStoreConfig('catalog/frontend/list_mode'), 0, 4));
		$rows = Mage::app()->getRequest()->getParam('limit', Mage::getStoreConfig('catalog/frontend/'.$mode.'_per_page'));
		$start = (Mage::app()->getRequest()->getParam('p', 1) - 1) * $rows;
        $sort = Mage::app()->getRequest()->getParam('order', 'score');
        $dir = Mage::app()->getRequest()->getParam('dir', 'desc');
        $facets_label = Mage::app()->getRequest()->getParam('facets_label', array());
		$facets_value = Mage::app()->getRequest()->getParam('facets_value', array());
        $params = '';
        //$cookie = new stdClass;
        foreach($facets_label as $i => $facet_label) {
            $facet_label_decoded = urldecode($facet_label);
            //$cookie->{$facet_label_decoded}[] = urldecode($facets_value[$i]);
            $params .= '|ff=' . $facet_label_decoded . ":" . urldecode($facets_value[$i]);
        }
        /*$_COOKIE["cvetta.search.facets"] = json_encode($cookie);
        //die('wwwww');
        //setrawcookie("cvetta.search.facets", $cookie);
        echo "<pre>";
        echo print_r($cookie);
        echo "</pre>";
        echo "<pre>";
        echo print_r($_COOKIE);
        echo "</pre>";*/
        $params = urlencode($params);

		$url = $this->host . '?qt=find&q='.$q.'&params='.$params.'&start='.$start.'&rows='.$rows.'&idvetrina='.$id_vetrina.'&sort='.$sort.'+'.$dir;
		
		$ch = curl_init();
        $curlOptArr = array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => TRUE
        );
        curl_setopt_array($ch, $curlOptArr);
        $output = curl_exec($ch);
        curl_close($ch);
		
		$output = substr($output, 11, -1);
		$output = json_decode($output, true);
		
		$numFound = $output["response"]["numFound"];
		$products = $output["response"]["docs"];

		//$this->facets["facet_ranges"] = array();
		$facet_ranges = array();
		foreach ($output["facet_counts"]["facet_ranges"] as $facet => $facet_values) {
			foreach($facet_values["counts"] as $value => $count) {
				//$this->facets["facet_ranges"][$facet][] = '['.$count.'+TO+'.($count+$counts["gap"]).']';
				$facet_ranges["facet_ranges"][$facet]['['.$value.'+TO+'.($value+$facet_values["gap"]).']'] = $count;
			}
		}
		//print_r($facet_ranges); die();
		//$this->facets["facet_fields"] = $output["facet_counts"]["facet_fields"];
		$this->facets = array_merge(array("facet_fields" => $output["facet_counts"]["facet_fields"]), $facet_ranges);
		//$this->facets = $output["facet_counts"]["facet_fields"];
		//var_dump($this->facets);
		//die();
		/*FINE RINDONDANTE*/

		return $this->facets;
	}
}